
/*
Software zum Seriellen Senden der Joystick- und Buttondaten eines Nunchucks, z.b. mittels XBee
Version: 1.0

Diese Software empfängt die Daten in der Form xWert,yWert,zButton,cButton* und steuert damit einen Bescor MP-101 aka Soligor Motorschwenkneiger aka Maxwell MP-101 sowie eine angeschlossene Nikon D3/D300 per Kabel

*/

#include <MsTimer2.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>



LiquidCrystal_I2C lcd(0x27,16,2); //I2C ADRESSE



#define left 11  //Pin 11 controls left pan //gelb
#define right 3 //Pin 3 controls right pan // grün
#define up 10   //Pin 10 controls up tilt //schwarz
#define down 9         //Pin 9 controls down tilt //blau
#define shutter 7
#define focus 6
#define ground 8

char current = 0; // Einzelzeichen über serial
char data[15]; // Zeichenpuffer Gesamtdaten
int incount = 0; // Zähler für Pufferzeiger
boolean lineComplete = false; // Merker ob Zeilenende erreicht wurde
int exp_tm = 100; //wie lange soll das Steuersignal gesendet werden?
int focus_tm = 200; //Fokussignal

char* X;
char* Y;
char* Z;
char* C;
int xWert = 0; // integer X-Wert nach atoi Operation
int absx = 0;//absoluter x-wert für speed
int xtemp;
int yWert = 0; // integer Y-Wert nach atoi Operation
int absy=0;//absoluter y-wert für speed
int ytemp;
int zTaster = 0;
int cTaster = 0;

int loop_cnt=0;
int lcd_delay=0;
int lcd_off=0;;
boolean runState = false; //soll ich laufen oder nicht?
unsigned long buttonpressedtime; //
int nullposition_X = 130; //die joystick center stellung
int nullposition_Y = 127; //die joystick center stellung


void setup()
{
  lcd.init();              // start the library
  lcd.backlight();
  lcd_off=0;
  Serial.begin(9600);
  pinMode(shutter,        OUTPUT);
  pinMode(focus,        OUTPUT);
  pinMode(ground,        OUTPUT);
    pinMode(left,        OUTPUT);
  pinMode(up,        OUTPUT);
  pinMode(right,        OUTPUT);
 pinMode(down,        OUTPUT);
  digitalWrite(shutter, HIGH);
  digitalWrite(focus, HIGH);
  digitalWrite(ground, LOW);
}

void loop()
{
  
  
  while ( Serial.available() > 0 &!lineComplete & incount < 20 ) //solange input da ist, die Nachricht nicht mit * abgeschlossen wurde und nicht mehr als 22 Zeichen eingegeben wurden
  {
    
    current = Serial.read();
    if (current != 42) //ASCII 42 == ‘*’ // solange Zeichen lesen bis der Sternchen den Datensatz abschließt
    {
      data[incount] = current;
      incount++;
    }
    else
    {
      data[incount] = '\0'; // puffer mit NULL Zeichen abschließen, damit das Ende der Zeichenkette durch string Operationen erkannt wird
      lineComplete = true;
      
    }
  }

  if (lineComplete)
  {
    lineComplete=false;
    incount=0;
    datenAuswerten();
    runStatus();
    
//    Serial.print("X Wert:");
//    Serial.println(xWert);
//    Serial.print("Y Wert:");
//    Serial.println(yWert);
//    Serial.print("Z Taster:");
//    Serial.println(zTaster);
//    Serial.print("C Taster");
//    Serial.println(cTaster);
  }



if (lcd_delay > 50)
{
  lcd_delay=0;
update_display();
}
lcd_delay++;

if (runState)
{  
 bewegen();
}

shootCamera();
sendStatus();  



if (lcd_off > 10000)
  {
   lcd.noBacklight();
  }
  
lcd_off++;

}




void datenAuswerten ()
{
    //eingehende Daten sind: xWert,yWert,zTaster,cTaster*
  X = strtok(data,",");
  Y = strtok('\0', ",");
  Z = strtok('\0', ",");
  C = strtok('\0', "*");


  
  xtemp=atoi(X); //0....255//
  ytemp=atoi(Y); 
  
  xWert = map(xtemp,0,255,-127,+127);
  yWert = map(ytemp,0,255,-127,+127);
 // xWert=(nullposition_X - xtemp)*-1; //130-130=0
 // yWert=(nullposition_Y - ytemp)*-1;//-127...+127

  zTaster=atoi(Z);
  cTaster=atoi(C);  



}

void runStatus()
{  

  if (buttonpressedtime+500 <millis())
  {
   if (cTaster == 1 & zTaster == 0)
    {
      
       if (!runState)
      {
       runState=true;
       lcd_off=0;
       lcd.backlight();
      }
      else
      {
       runState=false; 
       lcd_off=0;
       lcd.backlight();
    
      }
     buttonpressedtime = millis();
    } 
  }
}

void bewegen()
{
    
  // The values used for speed
  lcd.setCursor(0,12);  
  absx=xWert;

  absx=abs(absx);// Convert the x-axis value to an absolute value

  absy=yWert;

  absy=abs(absy);
  // Tilt based on the input from the joystick

  if(yWert > 18)  
  {    
    analogWrite(up,absy*4);
    digitalWrite(down,LOW);
  }


  else if (yWert < -18)
  {   
    analogWrite(down,absy*4);
    digitalWrite(up,LOW); 
  }


  // Stop tilt

  else  
  {    
    analogWrite(up,LOW);
    analogWrite(down,LOW);
  }


  // Pan based on the input from the joystick

  if(xWert > 20)  
  {    
    analogWrite(right,absx*12);
    digitalWrite(left,LOW);  
  }


  else if(xWert < -20)

  {   
    analogWrite(left,absx*12);
    digitalWrite(right,LOW);
  }


  // Stop pan

  else

  {
    analogWrite(right,LOW);
    analogWrite(left,LOW);
  }

  

}

void sendStatus(){
 if (loop_cnt > 50)
 {
   loop_cnt=0;
   if (runState)
    {
      Serial.print("R");
    }
   else
  {
   Serial.print("S");
  } 
}
  loop_cnt++;
  }








